Index: palm/trunk/SOURCE/lpm_collision_kernels.f90
===================================================================
--- palm/trunk/SOURCE/lpm_collision_kernels.f90	(revision 1821)
+++ palm/trunk/SOURCE/lpm_collision_kernels.f90	(revision 1822)
@@ -1087,140 +995,3 @@
     END SUBROUTINE turb_enhance_eff
 
-
-
-!------------------------------------------------------------------------------!
-! Description:
-! ------------
-!> Collision efficiencies from table 8.2 in Rogers and Yau (1989, 3rd edition).
-!> Values are calculated from table by bilinear interpolation.
-!------------------------------------------------------------------------------!
- 
-    SUBROUTINE collision_efficiency_rogers( mean_r, r, e)
-
-       IMPLICIT NONE
-
-       INTEGER(iwp)  ::  i !<
-       INTEGER(iwp)  ::  j !<
-       INTEGER(iwp)  ::  k !<
-
-       LOGICAL, SAVE ::  first = .TRUE. !<
-
-       REAL(wp)      ::  aa      !<
-       REAL(wp)      ::  bb      !<
-       REAL(wp)      ::  cc      !<
-       REAL(wp)      ::  dd      !<
-       REAL(wp)      ::  dx      !<
-       REAL(wp)      ::  dy      !<
-       REAL(wp)      ::  e       !<
-       REAL(wp)      ::  gg      !<
-       REAL(wp)      ::  mean_r  !<
-       REAL(wp)      ::  mean_rm !<
-       REAL(wp)      ::  r       !<
-       REAL(wp)      ::  rm      !<
-       REAL(wp)      ::  x       !<
-       REAL(wp)      ::  y       !<
- 
-       REAL(wp), DIMENSION(1:9), SAVE      ::  collected_r = 0.0_wp !<
-       
-       REAL(wp), DIMENSION(1:19), SAVE     ::  collector_r = 0.0_wp !<
-       
-       REAL(wp), DIMENSION(1:9,1:19), SAVE ::  ef = 0.0_wp          !<
-
-       mean_rm = mean_r * 1.0E06_wp
-       rm      = r      * 1.0E06_wp
-
-       IF ( first )  THEN
-
-          collected_r = (/    2.0_wp,    3.0_wp,    4.0_wp,    6.0_wp,    8.0_wp, &
-                             10.0_wp,   15.0_wp,   20.0_wp,   25.0_wp /)
-          collector_r = (/   10.0_wp,   20.0_wp,   30.0_wp,   40.0_wp,   50.0_wp, &
-                             60.0_wp,   80.0_wp,  100.0_wp,  150.0_wp,  200.0_wp, &
-                            300.0_wp,  400.0_wp,  500.0_wp,  600.0_wp, 1000.0_wp, &
-                           1400.0_wp, 1800.0_wp, 2400.0_wp, 3000.0_wp /)
-
-          ef(:,1)  = (/ 0.017_wp, 0.027_wp, 0.037_wp, 0.052_wp, 0.052_wp,      &
-                        0.052_wp, 0.052_wp, 0.0_wp,   0.0_wp /)
-          ef(:,2)  = (/ 0.001_wp, 0.016_wp, 0.027_wp, 0.060_wp, 0.12_wp,       &
-                        0.17_wp,  0.17_wp,  0.17_wp,  0.0_wp /)
-          ef(:,3)  = (/ 0.001_wp, 0.001_wp, 0.02_wp,  0.13_wp,  0.28_wp,       &
-                        0.37_wp,  0.54_wp,  0.55_wp,  0.47_wp/)
-          ef(:,4)  = (/ 0.001_wp, 0.001_wp, 0.02_wp,  0.23_wp,  0.4_wp,        &
-                        0.55_wp,  0.7_wp,   0.75_wp,  0.75_wp/)
-          ef(:,5)  = (/ 0.01_wp,  0.01_wp,  0.03_wp,  0.3_wp,   0.4_wp,        &
-                        0.58_wp,  0.73_wp,  0.75_wp,  0.79_wp/)
-          ef(:,6)  = (/ 0.01_wp,  0.01_wp,  0.13_wp,  0.38_wp,  0.57_wp,       &
-                        0.68_wp,  0.80_wp,  0.86_wp,  0.91_wp/)
-          ef(:,7)  = (/ 0.01_wp,  0.085_wp, 0.23_wp,  0.52_wp,  0.68_wp,       &
-                        0.76_wp,  0.86_wp,  0.92_wp,  0.95_wp/)
-          ef(:,8)  = (/ 0.01_wp,  0.14_wp,  0.32_wp,  0.60_wp,  0.73_wp,       &
-                        0.81_wp,  0.90_wp,  0.94_wp,  0.96_wp/)
-          ef(:,9)  = (/ 0.025_wp, 0.25_wp,  0.43_wp,  0.66_wp,  0.78_wp,       &
-                        0.83_wp,  0.92_wp,  0.95_wp,  0.96_wp/)
-          ef(:,10) = (/ 0.039_wp, 0.3_wp,   0.46_wp,  0.69_wp,  0.81_wp,       &
-                        0.87_wp,  0.93_wp,  0.95_wp,  0.96_wp/)
-          ef(:,11) = (/ 0.095_wp, 0.33_wp,  0.51_wp,  0.72_wp,  0.82_wp,       &
-                        0.87_wp,  0.93_wp,  0.96_wp,  0.97_wp/)
-          ef(:,12) = (/ 0.098_wp, 0.36_wp,  0.51_wp,  0.73_wp,  0.83_wp,       &
-                        0.88_wp,  0.93_wp,  0.96_wp,  0.97_wp/)
-          ef(:,13) = (/ 0.1_wp,   0.36_wp,  0.52_wp,  0.74_wp,  0.83_wp,       &
-                        0.88_wp,  0.93_wp,  0.96_wp,  0.97_wp/)
-          ef(:,14) = (/ 0.17_wp,  0.4_wp,   0.54_wp,  0.72_wp,  0.83_wp,       &
-                        0.88_wp,  0.94_wp,  0.98_wp,  1.0_wp /)
-          ef(:,15) = (/ 0.15_wp,  0.37_wp,  0.52_wp,  0.74_wp,  0.82_wp,       &
-                        0.88_wp,  0.94_wp,  0.98_wp,  1.0_wp /)
-          ef(:,16) = (/ 0.11_wp,  0.34_wp,  0.49_wp,  0.71_wp,  0.83_wp,       &
-                        0.88_wp,  0.94_wp,  0.95_wp,  1.0_wp /)
-          ef(:,17) = (/ 0.08_wp,  0.29_wp,  0.45_wp,  0.68_wp,  0.8_wp,        &
-                        0.86_wp,  0.96_wp,  0.94_wp,  1.0_wp /)
-          ef(:,18) = (/ 0.04_wp,  0.22_wp,  0.39_wp,  0.62_wp,  0.75_wp,       &
-                        0.83_wp,  0.92_wp,  0.96_wp,  1.0_wp /)
-          ef(:,19) = (/ 0.02_wp,  0.16_wp,  0.33_wp,  0.55_wp,  0.71_wp,       &
-                        0.81_wp,  0.90_wp,  0.94_wp,  1.0_wp /)
-
-       ENDIF
-
-       DO  k = 1, 8
-          IF ( collected_r(k) <= mean_rm )  i = k
-       ENDDO
-
-       DO  k = 1, 18
-          IF ( collector_r(k) <= rm )  j = k
-       ENDDO
-
-       IF ( rm < 10.0_wp )  THEN
-          e = 0.0_wp
-       ELSEIF ( mean_rm < 2.0_wp )  THEN
-          e = 0.001_wp
-       ELSEIF ( mean_rm >= 25.0_wp )  THEN
-          IF( j <= 2 )  e = 0.0_wp
-          IF( j == 3 )  e = 0.47_wp
-          IF( j == 4 )  e = 0.8_wp
-          IF( j == 5 )  e = 0.9_wp
-          IF( j >=6  )  e = 1.0_wp
-       ELSEIF ( rm >= 3000.0_wp )  THEN
-          IF( i == 1 )  e = 0.02_wp
-          IF( i == 2 )  e = 0.16_wp
-          IF( i == 3 )  e = 0.33_wp
-          IF( i == 4 )  e = 0.55_wp
-          IF( i == 5 )  e = 0.71_wp
-          IF( i == 6 )  e = 0.81_wp
-          IF( i == 7 )  e = 0.90_wp
-          IF( i >= 8 )  e = 0.94_wp
-       ELSE
-          x  = mean_rm - collected_r(i)
-          y  = rm - collector_r(j)
-          dx = collected_r(i+1) - collected_r(i)
-          dy = collector_r(j+1) - collector_r(j)
-          aa = x**2 + y**2
-          bb = ( dx - x )**2 + y**2
-          cc = x**2 + ( dy - y )**2
-          dd = ( dx - x )**2 + ( dy - y )**2
-          gg = aa + bb + cc + dd
-
-          e = ( (gg-aa)*ef(i,j) + (gg-bb)*ef(i+1,j) + (gg-cc)*ef(i,j+1) + &
-                (gg-dd)*ef(i+1,j+1) ) / (3.0_wp * gg)
-       ENDIF
-
-    END SUBROUTINE collision_efficiency_rogers
-
  END MODULE lpm_collision_kernels_mod
Index: palm/trunk/SOURCE/lpm_data_output_particles.f90
===================================================================
--- palm/trunk/SOURCE/lpm_data_output_particles.f90	(revision 1821)
+++ palm/trunk/SOURCE/lpm_data_output_particles.f90	(revision 1822)
@@ -19,5 +19,5 @@
 ! Current revisions:
 ! ------------------
-! 
+! Tails removed. Unused variables removed.
 !
 ! Former revisions:
@@ -58,5 +58,5 @@
 
     USE control_parameters,                                                    &
-        ONLY:  prt_time_count, simulated_time
+        ONLY:  simulated_time
 
     USE cpulog,                                                                &
@@ -68,12 +68,6 @@
     USE kinds
 
-    USE netcdf_interface,                                                      &
-        ONLY:  nc_stat
-
     USE particle_attributes,                                                   &
-        ONLY:  grid_particles, maximum_number_of_particles,                    &
-               maximum_number_of_tailpoints, maximum_number_of_tails,          &
-               number_of_particles, number_of_tails, particles,                &
-               particle_tail_coordinates, prt_count
+        ONLY:  grid_particles, number_of_particles,  particles, prt_count
 
     IMPLICIT NONE
@@ -103,11 +97,4 @@
        ENDDO
     ENDDO
-!
-!-- particle tails currently not available
-!    WRITE ( 85 )  maximum_number_of_tailpoints, maximum_number_of_tails, &
-!                  number_of_tails
-!    IF ( maximum_number_of_tails > 0 )  THEN
-!       WRITE ( 85 )  particle_tail_coordinates, prt_time_count
-!    ENDIF
 
     CALL close_file( 85 )
Index: palm/trunk/SOURCE/lpm_droplet_collision.f90
===================================================================
--- palm/trunk/SOURCE/lpm_droplet_collision.f90	(revision 1821)
+++ palm/trunk/SOURCE/lpm_droplet_collision.f90	(revision 1822)
@@ -19,5 +19,9 @@
 ! Current revisions:
 ! ------------------
-! 
+! Integration of a new collision algortithm based on Shima et al. (2009) and
+! Soelch and Kaercher (2010) called all_or_nothing. The previous implemented 
+! collision algorithm is called average_impact. Moreover, both algorithms are 
+! now positive definit due to their construction, i.e., no negative weighting 
+! factors should occur.
 ! 
 ! Former revisions:
@@ -63,10 +67,5 @@
 !> Calculates change in droplet radius by collision. Droplet collision is
 !> calculated for each grid box seperately. Collision is parameterized by
-!> using collision kernels. Three different kernels are available:
-!> PALM kernel: Kernel is approximated using a method from Rogers and
-!>              Yau (1989, A Short Course in Cloud Physics, Pergamon Press).
-!>              All droplets smaller than the treated one are represented by
-!>              one droplet with mean features. Collision efficiencies are taken
-!>              from the respective table in Rogers and Yau.
+!> using collision kernels. Two different kernels are available:
 !> Hall kernel: Kernel from Hall (1980, J. Atmos. Sci., 2486-2507), which
 !>              considers collision due to pure gravitational effects.
@@ -85,8 +84,8 @@
 
     USE arrays_3d,                                                             &
-        ONLY:  diss, ql, ql_v, ql_vp, u, v, w, zu, zw
+        ONLY:  diss, ql_v, ql_vp
 
     USE cloud_parameters,                                                      &
-        ONLY:  effective_coll_efficiency
+        ONLY:  rho_l
 
     USE constants,                                                             &
@@ -94,5 +93,5 @@
 
     USE control_parameters,                                                    &
-        ONLY:  dt_3d, message_string, u_gtrans, v_gtrans, dz
+        ONLY:  dt_3d, message_string, dz
 
     USE cpulog,                                                                &
@@ -100,18 +99,18 @@
 
     USE grid_variables,                                                        &
-        ONLY:  ddx, dx, ddy, dy
-
-    USE indices,                                                               &
-        ONLY:  nxl, nxr, nyn, nys, nzb, nzt 
+        ONLY:  dx, dy
 
     USE kinds
 
     USE lpm_collision_kernels_mod,                                             &
-        ONLY:  ckernel, collision_efficiency_rogers, recalculate_kernel
+        ONLY:  ckernel, recalculate_kernel
 
     USE particle_attributes,                                                   &
-        ONLY:  deleted_particles, dissipation_classes, hall_kernel,            &
-               palm_kernel, particles, particle_type,                          &
-               prt_count, use_kernel_tables, wang_kernel
+        ONLY:  all_or_nothing, average_impact, dissipation_classes,            &
+               hall_kernel, iran_part, number_of_particles, particles,         &
+               particle_type, prt_count, use_kernel_tables, wang_kernel
+
+    USE random_function_mod,                                                   &
+        ONLY:  random_function
 
     USE pegrid
@@ -121,108 +120,35 @@
     INTEGER(iwp) ::  eclass   !<
     INTEGER(iwp) ::  i        !<
-    INTEGER(iwp) ::  ii       !<
-    INTEGER(iwp) ::  inc      !<
-    INTEGER(iwp) ::  is       !<
     INTEGER(iwp) ::  j        !<
-    INTEGER(iwp) ::  jj       !<
-    INTEGER(iwp) ::  js       !<
     INTEGER(iwp) ::  k        !<
-    INTEGER(iwp) ::  kk       !<
     INTEGER(iwp) ::  n        !<
-    INTEGER(iwp) ::  pse      !<
-    INTEGER(iwp) ::  psi      !<
+    INTEGER(iwp) ::  m        !<
     INTEGER(iwp) ::  rclass_l !<
     INTEGER(iwp) ::  rclass_s !<
 
-    INTEGER(iwp), DIMENSION(prt_count(k,j,i)) ::  rclass_v !<
-
-    LOGICAL, SAVE ::  first_flag = .TRUE. !<
-
-    TYPE(particle_type) :: tmp_particle   !<
-
-    REAL(wp) ::  aa       !<
-    REAL(wp) ::  auxn     !< temporary variables
-    REAL(wp) ::  auxs     !< temporary variables
-    REAL(wp) ::  bb       !<
-    REAL(wp) ::  cc       !<
-    REAL(wp) ::  dd       !<
-    REAL(wp) ::  ddV      !<
-    REAL(wp) ::  delta_r  !<
-    REAL(wp) ::  delta_v  !<
-    REAL(wp) ::  epsilon  !<
-    REAL(wp) ::  gg       !<
-    REAL(wp) ::  mean_r   !<
-    REAL(wp) ::  ql_int   !<
-    REAL(wp) ::  ql_int_l !<
-    REAL(wp) ::  ql_int_u !<
-    REAL(wp) ::  r3       !<
-    REAL(wp) ::  sl_r3    !<
-    REAL(wp) ::  sl_r4    !<
-    REAL(wp) ::  sum1     !<
-    REAL(wp) ::  sum2     !<
-    REAL(wp) ::  sum3     !<
-    REAL(wp) ::  u_int    !<
-    REAL(wp) ::  u_int_l  !<
-    REAL(wp) ::  u_int_u  !<
-    REAL(wp) ::  v_int    !<
-    REAL(wp) ::  v_int_l  !<
-    REAL(wp) ::  v_int_u  !<
-    REAL(wp) ::  w_int    !<
-    REAL(wp) ::  w_int_l  !<
-    REAL(wp) ::  w_int_u  !<
-    REAL(wp) ::  x        !<
-    REAL(wp) ::  y        !<
-
-    REAL(wp), DIMENSION(:), ALLOCATABLE ::  rad    !<
-    REAL(wp), DIMENSION(:), ALLOCATABLE ::  weight !<
-
-    REAL, DIMENSION(prt_count(k,j,i))    :: ck
-    REAL, DIMENSION(prt_count(k,j,i))    :: r3v
-    REAL, DIMENSION(prt_count(k,j,i))    :: sum1v
-    REAL, DIMENSION(prt_count(k,j,i))    :: sum2v
+    REAL(wp) ::  collection_probability  !< probability for collection
+    REAL(wp) ::  ddV                     !< inverse grid box volume
+    REAL(wp) ::  epsilon                 !< dissipation rate
+    REAL(wp) ::  factor_volume_to_mass   !< 4.0 / 3.0 * pi * rho_l
+    REAL(wp) ::  xm                      !< mean mass of droplet m
+    REAL(wp) ::  xn                      !< mean mass of droplet n
+
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  weight  !< weighting factor
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  mass    !< total mass of super droplet
 
     CALL cpu_log( log_point_s(43), 'lpm_droplet_coll', 'start' )
 
-!
-!-- Collision requires at least two particles in the box
-    IF ( prt_count(k,j,i) > 1 )  THEN
-!
-!--    First, sort particles within the gridbox by their size,
-!--    using Shell's method (see Numerical Recipes)
-!--    NOTE: In case of using particle tails, the re-sorting of
-!--    ----  tails would have to be included here!
-       IF ( .NOT. ( ( hall_kernel  .OR.  wang_kernel )  .AND.  &
-       use_kernel_tables ) )  THEN
-          psi = 0
-          inc = 1
-          DO WHILE ( inc <= prt_count(k,j,i) )
-             inc = 3 * inc + 1
-          ENDDO
-
-          DO WHILE ( inc > 1 )
-             inc = inc / 3
-             DO  is = inc+1, prt_count(k,j,i)
-                tmp_particle = particles(psi+is)
-                js = is
-                DO WHILE ( particles(psi+js-inc)%radius >             &
-                tmp_particle%radius )
-                   particles(psi+js) = particles(psi+js-inc)
-                   js = js - inc
-                   IF ( js <= inc )  EXIT
-                ENDDO
-                particles(psi+js) = tmp_particle
-             ENDDO
-          ENDDO
-       ENDIF
-
-       psi = 1
-       pse = prt_count(k,j,i)
+    number_of_particles   = prt_count(k,j,i)
+    factor_volume_to_mass = 4.0_wp / 3.0_wp * pi * rho_l 
+    ddV                   = 1 / ( dx * dy * dz )
+!
+!-- Collision requires at least one super droplet inside the box
+    IF ( number_of_particles > 0 )  THEN
 
 !
 !--    Now apply the different kernels
-       IF ( ( hall_kernel  .OR.  wang_kernel )  .AND.  &
-            use_kernel_tables )  THEN
-!
-!--       Fast method with pre-calculated efficiencies for
+       IF ( use_kernel_tables )  THEN
+!
+!--       Fast method with pre-calculated collection kernels for
 !--       discrete radius- and dissipation-classes.
 !--
@@ -244,57 +170,147 @@
 !--       Droplet collision are calculated using collision-coalescence
 !--       formulation proposed by Wang (see PALM documentation)
-!--       Since new radii after collision are defined by radii of all
-!--       droplets before collision, temporary fields for new radii and
-!--       weighting factors are needed
-          ALLOCATE(rad(1:prt_count(k,j,i)), weight(1:prt_count(k,j,i)))
-
-          rad    = 0.0_wp
-          weight = 0.0_wp
-
-          sum1v(1:prt_count(k,j,i)) = 0.0_wp
-          sum2v(1:prt_count(k,j,i)) = 0.0_wp
-
-          DO  n = 1, prt_count(k,j,i)
-
-             rclass_l = particles(n)%class
-!
-!--          Mass added due to collisions with smaller droplets
-             DO  is = n+1, prt_count(k,j,i)
-                rclass_s = particles(is)%class
-                auxs = ckernel(rclass_l,rclass_s,eclass) * particles(is)%weight_factor
-                auxn = ckernel(rclass_s,rclass_l,eclass) * particles(n)%weight_factor
-                IF ( particles(is)%radius <  particles(n)%radius )  THEN
-                   sum1v(n) =  sum1v(n)  + particles(is)%radius**3 * auxs
-                   sum2v(is) = sum2v(is) + auxn
-                ELSE
-                   sum2v(n)  = sum2v(n)  + auxs
-                   sum1v(is) = sum1v(is) + particles(n)%radius**3 * auxn
-                ENDIF
+!--       Temporary fields for total mass of super-droplet and weighting factors 
+!--       are allocated.
+          ALLOCATE(mass(1:number_of_particles), weight(1:number_of_particles))
+
+          mass(1:number_of_particles)   = particles(1:number_of_particles)%weight_factor * &
+                                          particles(1:number_of_particles)%radius**3     * &
+                                          factor_volume_to_mass
+          weight(1:number_of_particles) = particles(1:number_of_particles)%weight_factor
+
+          IF ( average_impact )  THEN  ! select collision algorithm
+
+             DO  n = 1, number_of_particles
+
+                rclass_l = particles(n)%class
+                xn       = mass(n) / weight(n)
+
+                DO  m = n, number_of_particles
+
+                   rclass_s = particles(m)%class
+                   xm       = mass(m) / weight(m)
+
+                   IF ( xm .LT. xn )  THEN
+                      
+!
+!--                   Particle n collects smaller particle m
+                      collection_probability = ckernel(rclass_l,rclass_s,eclass) * &
+                                               weight(n) * ddV * dt_3d
+
+                      mass(n)   = mass(n)   + mass(m)   * collection_probability
+                      weight(m) = weight(m) - weight(m) * collection_probability
+                      mass(m)   = mass(m)   - mass(m)   * collection_probability
+                   ELSEIF ( xm .GT. xn )  THEN 
+!
+!--                   Particle m collects smaller particle n
+                      collection_probability = ckernel(rclass_l,rclass_s,eclass) * &
+                                               weight(m) * ddV * dt_3d
+
+                      mass(m)   = mass(m)   + mass(n)   * collection_probability
+                      weight(n) = weight(n) - weight(n) * collection_probability
+                      mass(n)   = mass(n)   - mass(n)   * collection_probability
+                   ELSE
+!
+!--                   Same-size collections. If n = m, weight is reduced by the
+!--                   number of possible same-size collections; the total mass 
+!--                   is not changed during same-size collection.
+!--                   Same-size collections of different 
+!--                   particles ( n /= m ) are treated as same-size collections 
+!--                   of ONE partilce with weight = weight(n) + weight(m) and 
+!--                   mass = mass(n) + mass(m).
+!--                   Accordingly, each particle loses the same number of 
+!--                   droplets to the other particle, but this has no effect on 
+!--                   total mass mass, since the exchanged droplets have the 
+!--                   same radius. 
+
+!--                   Note: For m = n this equation is an approximation only 
+!--                   valid for weight >> 1 (which is usually the case). The
+!--                   approximation is weight(n)-1 = weight(n).
+                      weight(n) = weight(n) - 0.5_wp * weight(n) *                &
+                                              ckernel(rclass_l,rclass_s,eclass) * &
+                                              weight(m) * ddV * dt_3d
+                      IF ( n .NE. m )  THEN 
+                         weight(m) = weight(m) - 0.5_wp * weight(m) *                &
+                                                 ckernel(rclass_l,rclass_s,eclass) * &
+                                                 weight(n) * ddV * dt_3d
+                      ENDIF
+                   ENDIF
+
+                ENDDO
+
+                ql_vp(k,j,i) = ql_vp(k,j,i) + mass(n) / factor_volume_to_mass
+
              ENDDO
-          ENDDO
-          rclass_v = particles(1:prt_count(k,j,i))%class
-          DO  n = 1, prt_count(k,j,i)
-            ck(n)       = ckernel(rclass_v(n),rclass_v(n),eclass)
-          ENDDO
-          r3v      = particles(1:prt_count(k,j,i))%radius**3
-          DO  n = 1, prt_count(k,j,i)
-             sum3 = 0.0_wp
-             ddV = ddx * ddy / dz
-!
-!--          Change of the current weighting factor
-             sum3 = 1 - dt_3d * ddV *                                 &
-                        ck(n) *                                       &
-                        ( particles(n)%weight_factor - 1 ) * 0.5_wp - &
-                    dt_3d * ddV * sum2v(n)
-             weight(n) = particles(n)%weight_factor * sum3
-!
-!--          Change of the current droplet radius
-             rad(n) = ( (r3v(n) + dt_3d * ddV * (sum1v(n) - sum2v(n) * r3v(n)) )/&
-                              sum3 )**0.33333333333333_wp
-
-             ql_vp(k,j,i) = ql_vp(k,j,i) + weight(n) &
-                                         * rad(n)**3
-
-          ENDDO
+
+          ELSEIF ( all_or_nothing )  THEN  ! select collision algorithm
+
+             DO  n = 1, number_of_particles
+
+                rclass_l = particles(n)%class
+                xn       = mass(n) / weight(n) ! mean mass of droplet n
+
+                DO  m = n, number_of_particles
+
+                   rclass_s = particles(m)%class
+                   xm = mass(m) / weight(m) ! mean mass of droplet m
+
+                   IF ( weight(n) .LT. weight(m) )  THEN
+!
+!--                   Particle n collects weight(n) droplets of particle m  
+                      collection_probability = ckernel(rclass_l,rclass_s,eclass) * &
+                                               weight(m) * ddV * dt_3d
+
+                      IF ( collection_probability .GT. random_function( iran_part ) )  THEN
+                         mass(n)   = mass(n)   + weight(n) * xm
+                         weight(m) = weight(m) - weight(n)
+                         mass(m)   = mass(m)   - weight(n) * xm
+                      ENDIF
+
+                   ELSEIF ( weight(m) .LT. weight(n) )  THEN 
+!
+!--                   Particle m collects weight(m) droplets of particle n  
+                      collection_probability = ckernel(rclass_l,rclass_s,eclass) * &
+                                               weight(n) * ddV * dt_3d
+
+                      IF ( collection_probability .GT. random_function( iran_part ) )  THEN
+                         mass(m)   = mass(m)   + weight(m) * xn
+                         weight(n) = weight(n) - weight(m)
+                         mass(n)   = mass(n)   - weight(m) * xn
+                      ENDIF
+                   ELSE
+!
+!--                   Collisions of particles of the same weighting factor. 
+!--                   Particle n collects 1/2 weight(n) droplets of particle m,
+!--                   particle m collects 1/2 weight(m) droplets of particle n.
+!--                   The total mass mass changes accordingly.
+!--                   If n = m, the first half of the droplets coalesces with the 
+!--                   second half of the droplets; mass is unchanged because
+!--                   xm = xn for n = m.
+
+!--                   Note: For m = n this equation is an approximation only 
+!--                   valid for weight >> 1 (which is usually the case). The
+!--                   approximation is weight(n)-1 = weight(n).
+                      collection_probability = ckernel(rclass_l,rclass_s,eclass) * &
+                                               weight(n) * ddV * dt_3d
+
+                      IF ( collection_probability .GT. random_function( iran_part ) )  THEN
+                         mass(n)   = mass(n)   + 0.5_wp * weight(n) * ( xm - xn )
+                         mass(m)   = mass(m)   + 0.5_wp * weight(m) * ( xn - xm )
+                         weight(n) = weight(n) - 0.5_wp * weight(m)
+                         weight(m) = weight(n)
+                      ENDIF
+                   ENDIF
+
+                ENDDO
+
+                ql_vp(k,j,i) = ql_vp(k,j,i) + mass(n) / factor_volume_to_mass
+
+             ENDDO
+
+          ENDIF
+
+
+
+
           IF ( ANY(weight < 0.0_wp) )  THEN
                 WRITE( message_string, * ) 'negative weighting'
